/*
 *  Copyright (C) 2014-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥  
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: CddRcCar.c 122 2015-07-17 01:31:28Z ertl-honda $
 */  

/*
 *		CDD SW-C CddRcCarѤε
 */

#include "Rte_CddRcCar.h"
#include "ModelCarControl.h"
#include "t_syslog.h"

/*
 *  PWMμ
 */
#define PWM_CYCLE_US	20000

/*
 * ƥ/®/֥졼λ
 */
static volatile IDT_Angle	angle_val = 0;
static volatile IDT_Speed	speed_val = 0;
static volatile IDT_Brake	brake_val = FALSE;

/*
 * ƥͤȼ®PWM
 */
static sint32	servo_pwm = SERVO_N_US;
static sint32	esc_pwm_100nsec = ESC_N_100NS;

/*
 *  CDD SW-C CddRcCarѤν
 */
void
CddRcCarInit(void)
{
	tInitPWM(PWM_CYCLE_US, SERVO_N_US, ESC_N_100NS/10);
}

/*
 * ƥRunnableEntity(ڥ졼ƽФ)
 */
void
SetSteerAngle(IDT_Angle angle)
{
	if ((angle <= STEER_ANGLE_MAX) && (angle >= STEER_ANGLE_MIN)) {
		angle_val = angle;
	}
}

/*
 * ®RunnableEntity(ڥ졼ƽФ)
 */
void
SetDriveSpeed(IDT_Speed speed)
{
	if ((speed <= DRIVE_SPEED_MAX) && (speed >= DRIVE_SPEED_MIN)) {
		speed_val = speed;
	}
}

/*
 * ֥졼RunnableEntity(ڥ졼ƽФ)
 */
void
SetBrake(IDT_Brake brake)
{
	brake_val = brake;
}

/*
 *  ESC
 */
typedef enum {
	DRIVE_STATE_DRIVE,
	DRIVE_STATE_REVERSE,
	DRIVE_STATE_DNEUTRAL,
	DRIVE_STATE_NEUTRAL,
	DRIVE_STATE_DRIVE2REVERSE,
	DRIVE_STATE_DRIVE2BRAKE,
	DRIVE_STATE_REVERSE2BRAKE,
}DRIVE_STATE;

/*
 *  PowreTrainʥ֥
 */
void
PowerTrain(void)
{
	static uint8		adjust_cnt = 0U;
	static IDT_Brake	pre_brake_val = FALSE;
	static DRIVE_STATE	drive_state = DRIVE_STATE_NEUTRAL;

	/*
	 * ƥ
	 */
	/* ɳȽ */
	if ((angle_val <= STEER_ANGLE_MAX) && (angle_val >= STEER_ANGLE_MIN)) {
		if (angle_val >= 0) {
			servo_pwm = SERVO_N_US - ((((SERVO_N_US - SERVO_LMAX_US) * 100) / (64 * 100)) * angle_val);
		}
		else {
			servo_pwm = SERVO_N_US + ((((SERVO_RMAX_US - SERVO_N_US) * 100) / (64 * 100)) * (-angle_val));
		}
		/* ƥ */
		tChangeServoDuty(servo_pwm);
	}

	/*
	 * ®
	 */
	if (adjust_cnt != 0U) {
		adjust_cnt--;
		if(adjust_cnt == 0){
			if(drive_state  == DRIVE_STATE_REVERSE2BRAKE) {
				tChangeESCDuty100NS(ESC_BREAK_100NS);
			}
			if(drive_state == DRIVE_STATE_DRIVE2REVERSE){
				drive_state = DRIVE_STATE_REVERSE;
				adjust_cnt = ESC_WAIT_N2R_WAIT_10MS;
				tChangeESCDuty100NS(ESC_N_100NS);
			}
		}
	}
	else if (pre_brake_val != brake_val) {
		/* ֥졼֤Ѳ */
		pre_brake_val = brake_val;
		/* ֥졼 */
		if (brake_val == FALSE) {
			if (speed_val < 0) {
				drive_state = DRIVE_STATE_REVERSE;
				adjust_cnt = ESC_WAIT_N2R_WAIT_10MS;
				tChangeESCDuty100NS(ESC_N_100NS);
			}
		}
		else {
			/* ֥졼 */
			if((drive_state == DRIVE_STATE_DRIVE) || (drive_state == DRIVE_STATE_DNEUTRAL)) {
				drive_state = DRIVE_STATE_DRIVE2BRAKE;
				tChangeESCDuty100NS(ESC_BREAK_100NS);
			}
			else if((drive_state == DRIVE_STATE_REVERSE) || (drive_state == DRIVE_STATE_NEUTRAL)) {
				drive_state = DRIVE_STATE_REVERSE2BRAKE;
				adjust_cnt = ESC_WAIT_D2B_WAIT_10MS;
				tChangeESCDuty100NS(ESC_DTH_100NS);
			}
		}
	}
	else if (brake_val == FALSE) {
		/* ®Ƚ */
		if ((speed_val <= DRIVE_SPEED_MAX) && (speed_val >= DRIVE_SPEED_MIN)) {
			/* ʤڤؤä */
			if ((drive_state == DRIVE_STATE_DNEUTRAL)  && (speed_val < 0)) {
				drive_state = DRIVE_STATE_DRIVE2REVERSE;
				adjust_cnt = ESC_WAIT_D2NR_WAIT_10MS;
				tChangeESCDuty100NS(ESC_D2R_100NS);
			}
			else {
				/*  */
				if (speed_val > 0) {
					esc_pwm_100nsec = ESC_DTH_100NS + (((ESC_DTH_100NS - ESC_DMAX_100NS) / 64) * (-1) * speed_val);
					drive_state = DRIVE_STATE_DRIVE;
				}
				/* ˥塼ȥ */
				if (speed_val == 0) {
					esc_pwm_100nsec = ESC_N_100NS;
					if (drive_state == DRIVE_STATE_DRIVE) {
						drive_state = DRIVE_STATE_DNEUTRAL;
					} else if (drive_state != DRIVE_STATE_DNEUTRAL){
						drive_state = DRIVE_STATE_NEUTRAL;
					}
				}
				/*  */
				if (speed_val < 0) {
					esc_pwm_100nsec = ESC_RTH_100NS + (((ESC_RMAX_100NS - ESC_RTH_100NS) / 64) * (-1) * speed_val);
					drive_state = DRIVE_STATE_REVERSE;
				}
				/* ® */
				tChangeESCDuty100NS(esc_pwm_100nsec);
			}
		}
	}
}

#ifdef TOPPERS_WITH_DISP
void
VehicleInfoReporter(void)
{
	/* ɳ */
	Rte_Write_VehicleInfoOut_angle(angle_val);

	/* ® */
	Rte_Write_VehicleInfoOut_speed(speed_val);

	/* ƥ󥰤ȼ®PWMͤޥñ̤ */
	Rte_Write_VehicleInfoOut_pwm_angle((IDT_PWM) servo_pwm);
	Rte_Write_VehicleInfoOut_pwm_speed((IDT_PWM) (esc_pwm_100nsec / 10));
}
#endif /* TOPPERS_WITH_DISP */
